package nts.interf;

import java.util.List;

import nts.interf.base.*;
import nts.interf.expr.IAccessBasic;
import nts.interf.expr.IHavoc;

/**
 * Procedure call interface.
 * 
 */
public interface ICall extends ILabel, IVisitable {
	/**
	 * 
	 * @return name of the callee
	 */
	public ISubsystem callee();
	/**
	 * 
	 * @return the actual parameters
	 */
	public List<IExpr> actualParameters();
	/**
	 * 
	 * @return the return variables
	 */
	public List<IAccessBasic> returnVars();
	/**
	 * 
	 * @return true iff the transition label contains a havoc part (transition of the form
	 * <tt> (y1', ... ,yn') = f(t1, ... ,tm) and havoc(x1, ... ,xo) </tt>
	 */
	public boolean hasHavoc();
	/**
	 * 
	 * @return the havoc part of the transition label (null if there is not any)
	 */
	public IHavoc havoc();
}
