package nts.interf.base;

import java.util.Set;


/**
 * Annotations of syntactical elements that can be annotated -- elements that are 
 * instances of classes implementing {@link IAnnotated} interface. 
 * Annotations are <tt>(attribute,value)</tt> pairs which are 
 * classified according to the attribute type -- integer, real, boolean, string, and formulae.
 **/
public interface IAnnotations extends IVisitable {
	public int getInt(String key);
	public float getReal(String key);
	public boolean getBool(String key);
	public String getString(String key);
	public IExpr getFormula(String key);
	
	public Set<String> keysInt();
	public Set<String> keysReal();
	public Set<String> keysBool();
	public Set<String> keysString();
	public Set<String> keysFormula();
}
