package nts.interf.expr;

import java.util.List;

import nts.interf.base.IAccess;
import nts.interf.base.IExpr;
import nts.interf.base.IVarTableEntry;

/**
 * An indexed access -- an accesses of the form <tt>a[i1]..[im]</tt>, 
 * where <tt>m>0</tt> and <tt>a</tt> is an array variable.
 * <p>
 * Indexed access can also represent the left-hand side of an array assignment (see ).
 *
 */
public interface IAccessIndexed extends IAccess, IExpr {
	/**
	 * 
	 * @return variable table entry for the accessed variable
	 */
	public IVarTableEntry var();
	/**
	 * 
	 * @return a non-empty list of index-expressions used in the array access
	 */
	public List<IExpr> indices();
}
