package nts.parser;

import org.antlr.runtime.Token;

import nts.interf.base.*;
import nts.interf.expr.IExprArraySize;

public class ArraySize extends Expr implements IExprArraySize {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	private Access term;
	public Access access() { return term; }
	
	public ArraySize(Token aTok, Access aTerm) {
		super(aTok, aTok);
		term = aTerm;
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags aS) {
		
		if (aS.noArrSizeOp()) {
			SemFlags.error(this, "array-size operator");
		}
		
		term.semanticChecks(aVT, aS);
		
		term.checkInputArray();
		
		type = new Type(EBasicType.INT);
		return this;
	}
	
	ArraySize syn_copy() {
		return new ArraySize(token,term.syn_copy());
	}
	
}
