package nts.parser;

import nts.interf.base.IVisitor;
import nts.interf.expr.IExprRemainder;

import org.antlr.runtime.Token;

public class ExRemainder extends OpBinArith implements IExprRemainder {

	public void accept(IVisitor v) { v.visit(this); }
	
	public ExRemainder(Token aT, Expr aE2, Expr aE1) { super(aT,aE2,aE1); }
	
	public static ExRemainder createRev(Token aT, Expr aE2, Expr aE1) { return new ExRemainder(aT,aE1,aE2); }
	
	ExRemainder syn_copy() { return new ExRemainder(token,op1.syn_copy(),op2.syn_copy()); }
	
	Expr semanticChecks(VarTable aVT, SemFlags seType) {
		
		super.semanticChecks(aVT, seType);
		
		if (op1.type.isReal()) {
			System.err.println("Semantic error at "+Common.at(token)+": remaider operator applicable only for INT type.");
			System.exit(1);
		}
		
		return this;
	}
}
