package nts.parser;

import org.antlr.runtime.Token;

import nts.interf.base.EBasicType;
import nts.interf.base.IVisitor;
import nts.interf.expr.IAccessBasic;
import nts.interf.expr.IHavoc;

import java.util.*;

public class Havoc extends Expr implements IHavoc {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	// unprimed variables in the havoc
	private List<Token> varsTok;
	private List<IAccessBasic> vars;
	
	// interface
	public List<IAccessBasic> vars() { return vars; }
	public Type type() { return new Type(EBasicType.BOOL); }
	
	boolean isEmpty() { return vars.isEmpty(); }
	
	public Havoc(Token aTok, List<Token> aL) {
		super(aTok, aTok);
		varsTok = aL;
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags aS) {
		
		vars = new LinkedList<IAccessBasic>();
		
		SemFlags sf = SemFlags.addNoPrimed(aS);
		for (Token t : varsTok) {
			//VarTableEntry e = aVT.checkIfDeclar(t);
			AccessBasic a = new AccessBasic(t);
			a.semanticChecks(aVT, sf);
			vars.add(a);
		}
		
		type = new Type(EBasicType.BOOL);
		return this;
	}
	
	Havoc syn_copy() {
		Havoc e = new Havoc(token, new LinkedList<Token>(varsTok));
		e.varsTok = new LinkedList<Token>(varsTok);
		if (vars != null) {
			for (IAccessBasic a : vars) {
				e.vars.add(((AccessBasic)a).syn_copy());
			}
		}
		return e;
	}
	
}
