package nts.parser;

import nts.interf.base.EBasicType;
import nts.interf.base.IVisitor;
import nts.interf.expr.ILitInt;

import org.antlr.runtime.Token;

public class LitInt extends Expr implements ILitInt {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	private int val;
	public int value() { return val; }
	
	public LitInt(Token aToken) {
		super(aToken, aToken);
		val = Integer.parseInt(aToken.getText());
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags seType) {
		type = new Type(EBasicType.INT);
		return this;
	}
	
	LitInt syn_copy() {
		LitInt ret = new LitInt(token);
		ret.val = val;
		return ret;
	}
}
