package nts.parser;

import nts.interf.base.EBasicType;
import nts.interf.base.IVisitor;
import nts.interf.expr.ILitReal;

import org.antlr.runtime.Token;

public class LitReal extends Expr implements ILitReal {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	private float val;
	public float value() { return val; }
	
	public LitReal(Token aToken) {
		super(aToken, aToken);
		val = Float.parseFloat(aToken.getText());
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags seType) {
		type = new Type(EBasicType.REAL);
		return this;
	}
	
	LitReal syn_copy() {
		LitReal ret = new LitReal(token);
		ret.val = val;
		return ret;
	}

}
