package nts.parser;

import org.antlr.runtime.Token;

import nts.interf.base.IExprBin;

public abstract class OpBin extends Expr implements IExprBin {
	protected Expr op1, op2;
	
	protected OpBin(Token aT, Expr aE1, Expr aE2) {
		super(aT,aE1.first);
		op1 = aE1;
		op2 = aE2;
	}
	
	// implement IExprBin interface in the abstract class
	public Expr operand1() { return op1; }
	public Expr operand2() { return op2; }
	/////////////////////////////////////////////////////
	
	
	static void errNoMatch(Token aTok) {
		System.err.println("Semantic error around operator "+aTok.getText()+" "+Common.at(aTok)+": types of operands don't match.");
		System.exit(1);
	}
	
	Expr semanticChecks(VarTable aVT, SemFlags seType) {
		
		op1 = op1.semanticChecks(aVT, seType);
		op2 = op2.semanticChecks(aVT, seType);
		
		Type t1 = op1.type();
		Type t2 = op2.type();
		
		if (!t1.matches(t2)) {
			errNoMatch(token);
		}
		
		// only basic type
		op1.checkBasic();

		return this;
	}
}



