package nts.parser;

import org.antlr.runtime.Token;

import nts.interf.*;
import nts.interf.base.ILabel;
import nts.interf.base.IVisitor;

public class Transition extends AnnotatedBase implements ITransition {
	
	public void accept(IVisitor v) { v.visit(this); }
	
	private Token id;
	private ControlState from, to;
	private ILabel label;
	
	public boolean hasID() { return id != null; }
	public String id() { return id == null? null : id.getText(); }
	public ControlState from() { return from; }
	public ControlState to() { return to; }
	public ILabel label() { return label; }
	void label(ILabel aL) { label = aL; }
	
	public Transition(Token aId, ControlState aFrom, ControlState aTo, ILabel aLabel) {
		id = aId;
		from = aFrom;
		to = aTo;
		label = aLabel;
	}
}
